
/*  Intervallomètre photos pour APN Fujifilm conforme RR-80. 
    --------------------------------------------------------
    Permet de prendre des photos de façon séquentielle en choisissant l'écart entre chacune
    soit en secondes, soit en minutes soit en heures.
    
    Utilise les librairies "Metro" et "LiqidCystal" à joindre à la librairie Arduino
    Les tests on été effectués avec un shield "LCD Keypad" comprenant afficheur et boutons 
    poussoirs. 
    La selection se fait par le bouton select et les touches Haut et Bas.
    La mise en route par le bouton Gauche. Arrêt par bouton Droit.
    L'afficheur indique les photos déjà prises.

    Télecommande
    ------------
    Un bouton poussoir extérieur entrant Pin 11, avec résistance de tirage 4.7 à 10 K au moins,
    Permet de télécommander les prises de vue image par image à chaque appui.
    Une télécommande HF ou IR sur cette broche est aussi possible.
    //// Si cette option n'est pas utilisée, la Pin 11 est a relier à la masse./////
    
    Le dossier intégre le schéma et une proposition de typon pour la partie relais de commande.

    + de détails sur mon site 
    F5MNA  Mars 2013  ( Mon site http://f5mna.free.fr )
*/

#include <Metro.h>            // Inclu la librairie Metro 
int Photx;                    // Ordre nouvelle photos
int state0 = LOW;             // variables d'état des relais
// Initialise l objet metro avec un interval de 2000 milliseconds (2 secondes).
Metro metro0 = Metro(500);   //ecart entre photos
long Tmetro;                  // Variable ecart entre photos

//LCD
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground

int Tempo, Photos, t;
String SecMin;
int MoP = 12;          //Mise au point
int Phot = 13;         //Photo
boolean Start = false; // déclaration d'une variable "start" de type binaire destinée
                       // à la M/A start.  Initialisée à false


int sensorValue = 0;   // Pavé bouton
int sensorPin = A0;    // Assigne pin A0 pour l'entrée du pavé de 5 boutons
word val_key;          // Valeurs correspondant à l'appui sur un bouton
boolean control = false;

int Telec = 11;         //Entrée télécommande
boolean Teleco = false; // Choisir la télécommande

void setup(){
    
   //Presentation
    lcd.begin(16, 2); 
    lcd.setCursor(0, 0);
    lcd.print ("  APN FujiFilm  ");
    lcd.setCursor(0, 1);
    lcd.print ("     RR-80      ");
    delay(2500);
    lcd.setCursor(0, 0);
    lcd.print ("INTERVALLOMETRE ");
    lcd.setCursor(0, 1);
    lcd.print ("F5MNA  Version 1");
    delay(2500);
    lcd.setCursor(0, 0);
    lcd.print ("                 ");
    lcd.setCursor(0, 1);
    lcd.print ("                 ");
    lcd.setCursor(0, 0);
    lcd.print ("   Intervalle    ");
    lcd.setCursor(0, 1);
    lcd.print (" entre 2 photos  ");
    
    
  Serial.begin(9600);
  pinMode(MoP, OUTPUT);
  pinMode(Phot, OUTPUT);
  digitalWrite(MoP, LOW);   // Relais 1 repos
  digitalWrite(Phot, LOW);  // Relais 2 repos
  Tempo = 1;
  Photos = 0;
  Photx = 0;
  t = 4;
  SecMin = "secondes";
  digitalWrite(MoP, LOW);   // Relais 1 repos
  digitalWrite(Phot, LOW);  // Relais 2 repos
  
  pinMode(Telec, INPUT);    //Entré de la télécommande
}

void loop()
 {
  if (Teleco == 1)  //Option télécommande
   {
    Telecom();
    }
  sensorValue = analogRead(sensorPin); // lecture d'un bouton  
  val_key = int(sensorValue/100);      // valeur entière du bouton / 10 
 
   if (val_key < 10)  (Bouton());
  
   if (metro0.check() == 1) {         // Verifie si metro est toujours dans l'interval.
   if (state0==LOW)  { 
       state0=HIGH;
       Photx = 1;
       photo(); 
    } else {
      state0=LOW;
      Photx = 0;
    }
    }
 } 
  ///////////////////////////////////////////////////////////////////////////////////////
  void Bouton ()
  {
    
  if (val_key < 10){
  sensorValue = analogRead(sensorPin); // lecture d'un bouton  
  val_key = int(sensorValue/100);      // valeur entière du bouton / 10 
  switch (val_key) {
   
  case 1:  //Bouton Haut: augmente la tempo.
  delay (200);
  Teleco = false;
  if (control == true) {
  Tempo == Tempo++;
  lcd.setCursor(0, 0);
  lcd.print ("                ");
  lcd.setCursor(3, 0);
  lcd.print (Tempo);
  lcd.print (" ");
  lcd.print (SecMin);
  }
  break;
  
  case 3:  //Bouton Bas: diminue la tempo.
  delay (200);
  Teleco = false;
  if (control == true) {
  if (Tempo > 1){
  Tempo = Tempo--;
  lcd.setCursor(0, 0);
  lcd.print ("                ");
  lcd.setCursor(3, 0);
  lcd.print (Tempo);
  lcd.print (" ");
  lcd.print (SecMin);
  }}
  break;
   
  case 0:                 //Bouton Droite Arrêt
  delay(100);             // pause anti rebond
  control = false;
  Photx = 0;              // Ordre nouvelle photo à 0
  Start = 0;              //    "          "
  Tempo = 1;              // Repasse temporisation à l'unité
  Photos = 0;
  lcd.setCursor(0, 0);
  lcd.print ("                 ");
  lcd.setCursor(0, 1);
  lcd.print ("                 ");
  lcd.setCursor(0, 0);
  lcd.print ("   Intervalle    ");
  lcd.setCursor(0, 1);
  lcd.print (" entre 2 photos  ");
  break;
  
  case 4:  //Bouton Gauche
  delay(100);                       // pause anti rebond
  lcd.setCursor(0, 0);
  lcd.print ("                 ");
  lcd.setCursor(0, 1);
  lcd.print ("                 ");
  lcd.setCursor(0, 1);
  lcd.print (" Photos  prises "); 
  if (Teleco == false) {
  control = false;
  Photx = 1;                        // Autorisation photo
  Start = 1;                        // OK pour débuter le processus
  metro0.interval (Tempo * Tmetro );   //ecart entre photos
  ////////////////////////////////////////////////
  digitalWrite(MoP, HIGH);    // Mise au point
  delay (1000);                 // Durée de la mise au point
  digitalWrite(Phot, HIGH);     //Prise de la photo
  delay(500);                   // Appui
  digitalWrite(MoP, LOW);       // Relais 1 repos
  digitalWrite(Phot, LOW);      // Relais 2 repos
  Photos = Photos++;  
  lcd.setCursor(7, 0);
  lcd.print (Photos); 
  }  
  ////////////////////////////////////////////////
  break;
  
  case 7:                        // préselection s,m,heure
  delay(200);
  control = true;
  t = t++ ;
  if (t > 4) {(t = 1);}

  if (t == 1) {
  SecMin = "secondes";
  Tmetro = 500;
  }
  if (t == 2) {
  SecMin = "minutes";
  Tmetro = 30000;
  }
  if (t == 3) {
  SecMin = "heures";
  Tmetro = 1800000;
  } 
  if (t == 4) {
  Tmetro = 500;
  //////////////
  }
  lcd.setCursor(0, 0);
  if (t != 4){
  lcd.print ("                 ");
  lcd.setCursor(3, 0);
  lcd.print (Tempo);
  lcd.print (" ");
  lcd.print (SecMin);}
  else
  {    
   Teleco = 1;
   lcd.print ("  Telecommande  ");
  }
  
  break;
  }}}
  
  //-------------------------------------------------------------
   void Telecom() // Photos  prises une à une: soit par bouton poussoir soit par sortie télécom sur PIN 
  {
    int val = digitalRead (Telec);  // Attend action télécommande
    if (val==HIGH) {                  // Si action
    digitalWrite(MoP, HIGH);          // Mise au point
    delay (1000);                     // Durée de la mise au point
    digitalWrite(Phot, HIGH);         //Prise de la photo
    delay(500);                       // Appui
    digitalWrite(MoP, LOW);           // Relais 1 repos
    digitalWrite(Phot, LOW);          // Relais 2 repos
    Photos = Photos++;
    lcd.setCursor (0,0);
    lcd.print ("                 ");
    if (Photos < 1000) {(lcd.setCursor(7, 0));}
    if (Photos > 999) {(lcd.setCursor(6, 0));}
    lcd.print (Photos);
    lcd.setCursor(0, 1);
    lcd.print ("                 ");
    lcd.setCursor(0, 1);
    lcd.print (" Photos  prises "); 
  }}

  //-------------------------------------------------------------
   void photo()
  {
  if ((Photx == 1) and (Start == 1)){ 
  digitalWrite(MoP, HIGH);          // Mise au point
  delay (1000);                     // Durée de la mise au point
  digitalWrite(Phot, HIGH);         //Prise de la photo
  delay(500);                       // Appui
  digitalWrite(MoP, LOW);           // Relais 1 repos
  digitalWrite(Phot, LOW);          // Relais 2 repos
  Photos = Photos++;
  if (Photos < 1000) {(lcd.setCursor(7, 0));}
  if (Photos > 999) {(lcd.setCursor(6, 0));}
  lcd.print (Photos); 
  lcd.setCursor(0, 1);
  lcd.print ("                 ");
  lcd.setCursor(0, 1);
  lcd.print (" Photos  prises "); 

  }}

 

